﻿' PARAMETERS ("Main","<device>|<URL>|<filename>|<directory>|<add_date?>")
'
'Script that Grabs the webcam image, saves it and updates the devicestring showig the picture.
' 0.3 - 27-Dec-2011 COMPLETE re-write including image grabbing functionality (using hs.getURLimageEx)
'		WHY? Because numbered doesn't make sense. If you FTP or restore DATE and TIME info is LOST.
'		THEREFORE: the date and time should be in the file name.
'		WHY this date-format? It allows you to sort by filename and get date sorting.
'		Use Stamp 2.8 to rename your existing *numbered* files to files with a date in the name.
'  http://www.homeseer.com/support/homeseer/WebHelp2/scripting/internet/scripting_internet_geturlimageex.htm
'  http://www.homeseer.com/support/homeseer/WebHelp2/scripting/internet/scripting_internet_geturlimage.htm
' 0.2 - Added code that recognizes if the DJ_getimage_xx script did NOT capture an image and replaces 
'		it with an 'error' image.
'	Feb-09 2010 - added 'setdevicevalue=0' for devices that work correctly, now failing webcams were set to dev.val 9 but never reset to 0[
'	Sep-23 2009 - added writelog in case the word 'error' is in the string.
'	Jan-25 2010 - updated writelogs with strDebug >0 and >1 instead of =1 and =2
'				- if the 'ERROR' string is detected it will set the device value to '9'
' 0.1 - Added feature that CHECKS if a device is provided (strDevice) through parameters. If not, it will not try to update device-strings.
'	strDebug	Debug (0=off, 1=basic, 2=detailed -- '2' will not grab the image, only display debug info!!!)
'	-------------PARAMETERS	Note: the parameters are separated using pipes "|" !
'	strDevice	-The device (Example: W10) will get HTML code showing a small picture. Empty? no device updates. 
'	strURL		-URL that needs to be captured. Example: http://username:password@10.1.1.1/Jpeg/Camera.jpg
'	strFilename	-Filename for captured image. Example: "CameraDoorbell" (NO extension!)
'	strDirectory-Directory to save image file. Example: "html\Camera\Doorbell" 
'			(Base="<HS_base_directory>/html", don't add '\' at the end!)
'	strNumbered	-If "yes" it will add the date/time to your filename. Example: DoorOpen_2011-12-27_16-41-05.jpg
'
' File: homeseer_base/html/<strDirectory>/<strFilename><date>.jpg
'		Homeseer 2   /html/camera        /frontdoor_2011-12-24_14-38-00.jpg
' TODO
' - Right now the images need to be stored somewhere under the /Homeseer 2/html folder
' - Allow custom date formats?

Sub Main(ByVal varParameters)

	'--- Parameters
	Dim strURL as String
	Dim strFilename as String
	Dim strDirectory as String
	Dim strDevice as String
	Dim strNumbered as String
	Dim strDate as String
	Dim strPage as String
	Dim WebCamImage as String
	Dim strDebug as String
	Dim varVersion as String
	strDebug = 2    '--- Debug=2: only debugging no image will be grabbed!
	varVersion = "DJ_Webcam_0.3"
	
	'--- PARAMETERS
	strDevice = hs.stringitem(varParameters, 1, "|")
	strURL = hs.stringitem(varParameters, 2, "|")
	strFilename = hs.stringitem(varParameters, 3, "|")
	strDirectory = hs.stringitem(varParameters, 4, "|")
	strNumbered = hs.stringitem(varParameters, 5, "|")

	'--- Format the date (leading zero's)
	strDate = Year(Now()) & "-" & Right("0" & Month(Now()), 2) & "-" & Right("0" & Day(Now()), 2) & "_" & Right("0" & Hour(Now()), 2) & "-" & Right("0" & Minute(Now()), 2) & "-" & Right("0" & Second(Now()), 2)


	'--- DEBUG info
	If strDebug >1 then
		hs.WriteLog(varVersion, "<b>URL:</b> " & strURL & "<br>" & "<b>FILE:</b> " & strFilename & "<br>" & "<b>DIR:</b> " & strDirectory & "<br>" & "<b>DATE:</b>" & strDate & "<br>" & "<b>SERVER:</b> http://" & hs.stringitem(strURL,3,"/") & "<br>" & "<b>PATH:  </b> " & hs.stringitem(strURL,2,hs.stringitem(strURL,3,"/")))
	End if
	
	If strNumbered = "yes" then  '--- Add DATE
		strFilename = strDirectory + "\" + strFilename + "_" + strDate + ".jpg"
		If strDebug >0 then hs.WriteLog(varVersion,"<b>NAME+DATE:</b>" & strFilename)
	End if
	If strNumbered <> "yes" then '--- Use filename ONLY
		strFilename = strDirectory + "\" + strFilename + ".jpg"
		If strDebug >0 then hs.WriteLog(varVersion,"<b>NAME only:</b>" & strFilename)
	End if
	strPage = Replace(hs.stringitem(strFilename,2,"html\"),"\","/") '--- URL to image
	If strDebug >0 then hs.writelog(varVersion,"<b>IMAGE URL:</b> " & strPage)
	
	'--- GRAB the image and save it in the configured directory. strDebug > 1 will not grab the image!
	If strDebug < 2 then 
		If strDebug > 0 then hs.writelog(varVersion,"hs.getURLimageEx(" & hs.stringitem(strURL,3,"/") & ", " & hs.stringitem(strURL,2,hs.stringitem(strURL,3,"/")) & ", strFilename")
		WebCamImage = hs.getURLimageEx(hs.stringitem(strURL,3,"/"), hs.stringitem(strURL,2,hs.stringitem(strURL,3,"/")),strFilename)
	End if
	
	'--- ERROR Checking: if the word 'ERROR' appears in the results: point to the error-image
	If Instr(UCase(WebCamImage),"ERROR")<>0 then
		hs.SetDeviceValue(strDevice, 9)
		hs.WriteLog(varVersion,"String returned by <b>" & strURL & "</b> contained the word 'ERROR'")
		hs.WriteLog(varVersion,"The string itself:<b>" & Cstr(WebCamImage) & "</b>...")
		WebCamImage = "<img src='/Camera/CameraError.jpg' height='100'></img>"
	Else
		hs.SetDeviceValue(strDevice, 0)
	End if
	
	'--- UPDATE device and last-change date
	If strDevice <> "" then hs.SetDeviceString(strDevice , "<a href='" & strPage & "' target='_blank'><img src='" & strPage & "' height='100'/></a><br>" & strDate)
	If strDevice <> "" then hs.SetDeviceLastChange(strDevice, Now)
	WebCamImage = ""

	
End Sub







